﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace Primzahlen
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            timer.Interval = TimeSpan.FromSeconds(1);
            timer.Tick += update;
            timer.Start();

            arbeitsthread = new Thread(bestimmePrimzahlen);
            arbeitsthread.IsBackground = true;
            arbeitsthread.Start();
        }

        Thread arbeitsthread;
        DispatcherTimer timer = new DispatcherTimer();
        List<uint> primzahlen = new List<uint>();
        object dummy = new object();

        void bestimmePrimzahlen()
        {
            for (uint i = 2; i <= uint.MaxValue; i++)
            {
                Thread.Sleep(100);
                if (primzahlen.All(p => i % p != 0))
                {
                    lock (dummy)
                    {
                        primzahlen.Add(i);
                    }
                }
            }
        }

        void update(object sender, EventArgs e)
        {
            zeichenfläche.Children.Clear();
            Polyline poly = new Polyline();
            zeichenfläche.Children.Add(poly);
            poly.Stroke = Brushes.Red;
            poly.StrokeThickness = 2.0;
            poly.Points.Add(new Point(0.0, zeichenfläche.ActualHeight));
            lock(dummy)
            {
                for (int i = 0; i < primzahlen.Count; i++)
                {
                    uint p = primzahlen[i];
                    double x = zeichenfläche.ActualWidth / primzahlen.Last() * p;
                    double y1 = zeichenfläche.ActualHeight * (1.0 - i / (double) primzahlen.Count);
                    double y2 = zeichenfläche.ActualHeight * (1.0 - (i + 1) / (double)primzahlen.Count);
                    poly.Points.Add(new Point(x, y1));
                    poly.Points.Add(new Point(x, y2));
                }
            }
        }
    }
}
